* PageSet.s for nb46n.sys
* MMUe[u
* bZ[Wo

* 8kB / page only.
* 040 and 060 only.

		.include	doscall.mac

		.cpu		68040

		.xdef		_PageSet
		.xref		_i2h

.ifdef		__LF__
CRLF		.equ		$0a
.else
CRLF		.reg		$0d,$0a
.endif

		.text
		.even

_PageSet:
* void PageSet (int no, unsigned char flag, void *base);
* ̃`FbNȂǂĂȂ
		movem.l		d3-d7/a3-a6,-(sp)
	* ̎擾
		movem.l		4+(7-3+1+6-3+1)*4(sp),d0-d1/d4	* d0 no, d1 flag, d4 base
	* bZ[Wo
		addi.b		#'0',d0
		move.b		d0,noP
		pea		message(pc)
		DOS		__PRINT
		addq.l		#4,sp
	* oN̗L𒲂ׁAbZ[WI
		tst.b		d1
		bmi		@f
		pea		bank_dis(pc)
		bra		mesout
@@:
		move.l		d4,-(sp)
		pea		baseP(pc)
		bsr		_i2h
		addq.l		#8,sp
		pea		bank_en(pc)
	* to super
		clr.l		-(sp)
		DOS		__SUPER
		move.l		d0,(sp)
	* disable interrupt
		move		sr,-(sp)
		ori		#$0700,sr

	* get registers
		movec		srp,a0		* a0 SRP
		movec		sfc,d6		* d6 SFC
		movec		dfc,d7		* d7 DFC
	* flush cache/ATC
		cpusha		bc
		moveq		#5,d2		* supervisor data
		movec		d2,dfc
		pflusha		bc
	* set FC
		moveq		#3,d2		* mmu table-walk data
		movec		d2,sfc
		movec		d2,dfc
	* e[uY܂ŒH
		* TIA fBXNv^𓾂
		move.l		d4,d2
		rol.l		#7,d2
		andi.w		#$007F,d2
		moves.l		(d2.w*4,a0),d3
		andi.w		#$FE00,d3
		movea.l		d3,a0
		* TIB fBXNv^𓾂
		move.l		d4,d2
		swap		d2
		andi.w		#$01FC,d2
		moves.l		(d2.w,a0),d3
		andi.w		#$FF80,d3
		movea.l		d3,a0
		* TIC AhX𓾂
		move.l		d4,d2
		lsl.l		#5,d2
		swap		d2
		andi.w		#$007C,d2
		adda.w		d2,a0
	* 
		moveq		#8-1,d5		* d5 loop counter (8 * 8kB = 64kB)
@@:		moves.l		(a0),d3
		andi.w		#$FF9F,d3
		ori.w		#$0060,d3
		moves.l		d3,(a0)+
		dbra		d5,@b
	* flush cache/ATC
		cpusha		bc
		moveq		#5,d2		* supervisor data
		movec		d2,dfc
		pflusha		bc
	* restore registers
		movec		d6,sfc
		movec		d7,dfc

	* enable interrupt
		move		(sp)+,sr
	* to user
		tst.l		(sp)
		bmi		@f
		DOS		__SUPER
@@:		addq.l		#4,sp
mesout:	* bZ[Wo
		DOS		__PRINT
		addq.l		#4,sp

		movem.l		(sp)+,d3-d7/a3-a6
		rts


		.data

message:	.dc.b		' Nereid #'
noP:		.dc.b		'0'
		.dc.b		0

bank_en:	.dc.b		'̃oN($'
baseP:		.dc.b		'12345678'
		.dc.b		'`64kB)̃LbVmVACYhɕύX܂B'
		.dc.b		CRLF,0

bank_dis:	.dc.b		'ɃoN͂܂B'
		.dc.b		CRLF,0

		.end
