// nb46.c for nb46n.sys

#define __NO_LOCALE_INLINE__
#include <ctype.h>
#include <string.h>
#define __DOS_INLINE__
#include <sys/dos.h>
#define __IOCS_INLINE__
#include <sys/iocs.h>


extern void PageSet (int, unsigned char, void *);


int ChgMd (void)
{
int i;
int n = -1;	// Nereid  -> ++
static const void *iobase[2] = {0xECE300, 0xECEB00};	// Nereid I/O base
static const void *bank[2] = {0xEE0000, 0xEF0000};	// Nereid bank memory base

	for (i = 0; i < 2; i++) {
		char dum;
		if (_dos_bus_err (iobase[i] + 0xF1, &dum, 1) == 0) {	// +0xF1 : Nereid control register
			unsigned char tmp = *(unsigned char *)(iobase[i] + 0xF1);
			n++;
			PageSet (i, tmp, bank[(tmp >> 5) & 1]);	// bank[bit5]
		}
	}

	return n;
}


// eof
